// LabakAPDU.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "LabakAPDU.h"
#include "PCSCMngr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const BYTE APPLET_AID_LEN = 11;
const unsigned char APPLET_AID[APPLET_AID_LEN] = {0x53, 0x43, 0x53, 0x41, 0x54, 0x54, 0x65, 0x73, 0x74, 0x01, 0x01}; 
/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
    CPCSCMngr   scManager;
    char*       readers;
    char*       reader;
    DWORD       readersLen = 1000;  
    int         pos;
    CARDAPDU    apdu;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
        readers = new char[readersLen];
        memset(readers, 0, readersLen);

        if (scManager.GetAvailableReaders(readers, &readersLen) == STAT_OK) {
    		// PARSE NULL SEPARATED ARRAY
            cout << "Available readers:" << endl;
            pos = 0;
            while (pos < (int) readersLen) {
                reader = &(readers[pos]);
                // DISPLAY READER
                if (strlen(reader) > 0) cout << reader << endl;

                pos = pos + strlen(reader) + 1;
            }
        }
        else {
            cout << "Fail to obtain readers" << endl;
        }

        // CONNECT TO FIRST AVAILABLE READER AND EXCHANGE APDU COMMAND
        if (scManager.OpenSession(readers) == STAT_OK) {
            // PREAPARE SOME APDU ('SELECT' IN THIS CASE)
	        apdu.cla = 0x00;
	        apdu.ins = 0xA4;
	        apdu.p1 = 0x04;
	        apdu.p2 = 0x00;
	        apdu.le = 0x00;
	        apdu.lc = APPLET_AID_LEN;
	        memcpy(apdu.DataIn, APPLET_AID, APPLET_AID_LEN);


            if (scManager.ExchangeAPDU(&apdu) == STAT_OK) {
                // OK
            }

            scManager.CloseSession();
        }

        delete[] readers;
	}

	return nRetCode;
}


